//mkbmf ver.0.04
// ttf -> bmf(Be)
#include	<Be.h>

struct GLYPH{
	uint16	c;			//unicode
	uint16	w;			//width
	uint32	p;			//pointer(bitmap area)
};

bool	search_tbl(FILE *fp,uint32 tblname,char *s);
void	quit(char *p);

class mkbmf:public BApplication
{
	public:
		mkbmf(char *ifn,char *ofn,int p);
		void	xfer(uint16 c,uchar *d);
	private:
		BFont		*f;
		BBitmap		*b;
		BView		*v;
		font_height	fh;
		int			w,h;
		int			ox,oy;
};

main(int ac,char **ag)
{
	if(ac!=4)quit("mkbmf ver.0.04\nusage:\tmkbmf ttf-file bmf-file point");
	uint	fp;
	sscanf(ag[3],"%d",&fp);
	mkbmf	app(ag[1],ag[2],fp);
	app.Run();
	quit("");
}

bool search_tbl(FILE *fp,uint32 tblname,char *s)
{
	bool	f=false;
	fseek(fp,0,0);
	fread(s,1,12,fp);
	int		tbls=B_BENDIAN_TO_HOST_INT16(*(uint16*)(s+5));
	for(int i=0;i<tbls;i++){
		fread(s,1,16,fp);
		if(B_BENDIAN_TO_HOST_INT32(*(uint32*)s)==tblname){f=true;break;}
	}
if(!f){printf("not found\n");exit(1);}
	return(f);
}

void quit(char *p)
{
	if(*p)printf("%s\n",p);
	else printf("complete\n");
	exit(0);
}



mkbmf::mkbmf(char *ifn,char *ofn,int p):BApplication("application/x-vnd.Beer-mkbmf")
{
	char	ff[64],fs[64];
	FILE	*ifp,*ofp;
	uint32	ofl;			//length of output-file
	int		chrs;			//count of bitmap-char
	uint32	ltc;			//count of locate-table
	GLYPH	*g=NULL;
	char	s[256],wb[4096];

	if((ifp=fopen(ifn,"rb"))==NULL)quit("cannot open ttf-file");

printf("read name\n");
	search_tbl(ifp,'name',s);
	fseek(ifp,B_BENDIAN_TO_HOST_INT32(*(uint32*)(s+8)),0);
	uint32	nal=B_BENDIAN_TO_HOST_INT32(*(uint32*)(s+12));
	uchar	*na=new uchar[nal];
	fread(na,1,nal,ifp);
	uint16	nac=B_BENDIAN_TO_HOST_INT16(*(uint16*)(na+2));
	uint16	nao=B_BENDIAN_TO_HOST_INT16(*(uint16*)(na+4));
	for(int i=0;i<nac;i++){
		uint16	pid=B_BENDIAN_TO_HOST_INT16(*(uint16*)(na+i*12+6));
		uint16	nid=B_BENDIAN_TO_HOST_INT16(*(uint16*)(na+i*12+12));
		uint16	sl=B_BENDIAN_TO_HOST_INT16(*(uint16*)(na+i*12+14));
		uint16	sp=B_BENDIAN_TO_HOST_INT16(*(uint16*)(na+i*12+16));
//printf("pid=%d nid=%d sl=%x sp=%x\n",pid,nid,sl,sp);
		if((pid==1)&&(nid==1)){strncpy(ff,(char*)na+nao+sp,sl);ff[sl]=0;}
		if((pid==1)&&(nid==2)){strncpy(fs,(char*)na+nao+sp,sl);fs[sl]=0;}
	}
printf("fontname=[%s]-[%s]\n",ff,fs);
	delete	na;

printf("BFont\n");
	f=new BFont();
	f->SetFamilyAndStyle(ff,fs);
	f->SetSize(p);
	f->GetHeight(&fh);
//printf("ascent=%d descent=%d\n",(int)(fh.ascent),(int)(fh.descent));
	ox=p*0.2;oy=ceil(fh.ascent);
	w=p*1.4;h=oy+ceil(fh.descent);
	b=new BBitmap(BRect(0,0,w-1,h-1),B_RGB_32_BIT,true);
	v=new BView(BRect(0,0,w-1,h-1),"xferview",0,0);
	v->SetFont(f);
	v->SetHighColor(255,255,255,255);
	v->SetLowColor(0,0,0,0);
	b->AddChild(v);

printf("read maxp\n");
	search_tbl(ifp,'maxp',s);
	fseek(ifp,B_BENDIAN_TO_HOST_INT32(*(uint32*)(s+8)),0);
	fread(s,1,32,ifp);
	chrs=B_BENDIAN_TO_HOST_INT16(*(uint16*)(s+4));		//numGlyphs
//printf("chrs(maxp) : %d\n",chrs);
	for(ltc=1;ltc<chrs;ltc<<=1);
//printf("ltc=%d\n",ltc);
	g=new GLYPH[ltc+1];
	chrs=0;
printf("read head\n");
	search_tbl(ifp,'head',s);
	fseek(ifp,B_BENDIAN_TO_HOST_INT32(*(uint32*)(s+8)),0);
	fread(s,1,54,ifp);
	uint16	upe=B_BENDIAN_TO_HOST_INT16(*(uint16*)(s+18));		//unitsPerEm
//printf("upe=%x\n",upe);
printf("read hhea\n");
	search_tbl(ifp,'hhea',s);
	fseek(ifp,B_BENDIAN_TO_HOST_INT32(*(uint32*)(s+8)),0);
	fread(s,1,36,ifp);
	uint16	nohm=B_BENDIAN_TO_HOST_INT16(*(uint16*)(s+34));		//numberOfHMetrics
//printf("nohm=%d\n",nohm);
printf("read cmap\n");
	search_tbl(ifp,'cmap',s);
	fseek(ifp,B_BENDIAN_TO_HOST_INT32(*(uint32*)(s+8)),0);
	uint32	cml=B_BENDIAN_TO_HOST_INT32(*(uint32*)(s+12));
	uchar	*cm=new uchar[cml];
	fread(cm,1,cml,ifp);
printf("read hmtx\n");
	search_tbl(ifp,'hmtx',s);
	fseek(ifp,B_BENDIAN_TO_HOST_INT32(*(uint32*)(s+8)),0);
	uint32	hml=B_BENDIAN_TO_HOST_INT32(*(uint32*)(s+12));
	uchar	*hm=new uchar[hml];
	fread(hm,1,hml,ifp);
printf("scan cmap,hmtx\n");
	uint16	sc2=B_BENDIAN_TO_HOST_INT16(*(uint16*)(cm+288));	//segCountX2
	uint16	sr=B_BENDIAN_TO_HOST_INT16(*(uint16*)(cm+290));		//searchRange
	uint16	es=B_BENDIAN_TO_HOST_INT16(*(uint16*)(cm+292));		//entrySelector
	uint16	rs=B_BENDIAN_TO_HOST_INT16(*(uint16*)(cm+294));		//rangeShift
	uint16	*ecp=(uint16*)(cm+296);						//endCode
	uint16	*scp=(uint16*)(cm+298+sc2);					//startCode
	uint16	*idp=(uint16*)(cm+298+sc2*2);				//idDelta
	uint16	*irp=(uint16*)(cm+298+sc2*3);				//idRangeOffset
	for(int i=0;;i++){		//scan cmap table
		uint16	sc=B_BENDIAN_TO_HOST_INT16(*(scp++));	//startCode
		uint16	ec=B_BENDIAN_TO_HOST_INT16(*(ecp++));	//endCode
		uint16	id=B_BENDIAN_TO_HOST_INT16(*(idp++));	//idDelta
		uint16	ir=B_BENDIAN_TO_HOST_INT16(*(irp++));	//idRangeOffset
		if(sc==0xffff)break;
//printf("sc=%04x  ec=%04x  id=%04x  ir=%04x\n",sc,ec,id,ir);
		for(uint16 c=sc;c<=ec;c++){
			uint16	lo=0;
			lo=ir?B_BENDIAN_TO_HOST_INT16(*(irp-1+ir/2+c-sc)):c+id;
//printf("lo=%d\n",lo);
			if(lo){
				g[chrs].c=c;
				g[chrs].w=B_BENDIAN_TO_HOST_INT16(*(uint16*)(lo<nohm?hm+lo*4:hm+(nohm-1)*4));
//printf("%04x w=%d\n",c,g[chrs].w);
				chrs++;
			}
		}
	}
printf("chrs=%d\n",chrs);
	delete	cm;
	fclose(ifp);


	if((ofp=fopen(ofn,"wb"))==NULL)quit("cannot open bmf-file");
	uint32	hdl=0x0026+strlen(ff)+strlen(fs);
	for(int i=0;i<hdl;i++)wb[i]=0;
	*(uint32*)(wb+0x00)=B_HOST_TO_BENDIAN_INT32(0x7c42653b);
	*(uint32*)(wb+0x04)=B_HOST_TO_BENDIAN_INT32(hdl);
	*(uint16*)(wb+0x08)=B_HOST_TO_BENDIAN_INT16(strlen(ff));
	*(uint16*)(wb+0x0a)=B_HOST_TO_BENDIAN_INT16(strlen(fs));
	*(uint16*)(wb+0x16)=B_HOST_TO_BENDIAN_INT16(ltc-1);
	*(uint16*)(wb+0x18)=B_HOST_TO_BENDIAN_INT16(p);
	*(uint16*)(wb+0x1a)=B_HOST_TO_BENDIAN_INT16(0x300);
	strcpy(wb+0x0024,ff);
	strcpy(wb+0x0025+strlen(ff),fs);
	fwrite(wb,1,hdl,ofp);

	fseek(ofp,ltc*8,1);
	ofl=hdl+ltc*8;
printf("top of bitmap : %08x\n",ofl);

printf("xfer start\n");
	g[0].p=ofl;
	wb[0x00]=0x49;	wb[0x01]=0x96;	wb[0x02]=0xb4;	wb[0x03]=0x38;
	wb[0x04]=0x49;	wb[0x05]=0x96;	wb[0x06]=0xb4;	wb[0x07]=0x40;
	wb[0x14]=0x80;	wb[0x15]=0x00;	wb[0x16]=0x00;	wb[0x17]=0x00;
	for(int i=0;i<chrs;i++){
		*(float*)(wb+0x10)=B_HOST_TO_BENDIAN_FLOAT((float)g[i].w/upe*p);
		uchar	*d=new uchar[w*h];
		xfer(g[i].c,d);
//printf("no.=%d  code=%04x\n",i,g[i].c);
//for(int iy=0;iy<h;iy++){for(int ix=0;ix<w;ix++)printf("%d",d[w*iy+ix]);printf("\n");}
		int16	l,t,r,b;
		l=t=9999;	r=b=-9999;
		for(int y=0;y<h;y++)for(int x=0;x<w;x++){
			if(d[w*y+x]==0)continue;
			if(x<l)l=x;
			if(x>r)r=x;
			if(y<t)t=y;
			if(y>b)b=y;
		}
		uint32 len=24;
		if(l==9999){	//space
			*(uint16*)(wb+0x08)=0;
			*(uint16*)(wb+0x0a)=0;
			*(uint16*)(wb+0x0c)=-1;
			*(uint16*)(wb+0x0e)=-1;
		}else{			//non-space
			*(uint16*)(wb+0x08)=B_HOST_TO_BENDIAN_INT16(l-ox);
			*(uint16*)(wb+0x0a)=B_HOST_TO_BENDIAN_INT16(t-oy);
			*(uint16*)(wb+0x0c)=B_HOST_TO_BENDIAN_INT16(r-ox);
			*(uint16*)(wb+0x0e)=B_HOST_TO_BENDIAN_INT16(b-oy);
			for(int iy=t;iy<=b;iy++)for(int ix=l;ix<=r;ix+=2){
				wb[len]=(d[w*iy+ix]>>5)<<4;
				if(ix<r)wb[len]|=(d[w*iy+ix+1]>>5);
				len++;
			}
		}
		delete	d;
		g[i+1].p=g[i].p+len;
		fwrite(wb,1,len,ofp);
		ofl+=len;
	}

printf("make loca-table\n");
	uchar	*lt=new uchar[ltc*8];
	for(int i=0;i<ltc;i++){
		*(uint32*)(lt+i*8)=-1;
		*(uint32*)(lt+i*8+4)=0;
	}
	
	for(int i=0;i<chrs;i++){
		uint16	p=(g[i].c<<3)^(g[i].c>>2);
		p&=ltc-1;
//printf("i=%d  c=%04x  p=%04x\n",i,g[i].c,p);
		while(*(uint32*)(lt+p*8)!=-1)p=(p+1)&(ltc-1);
		*(uint32*)(lt+p*8)=B_HOST_TO_BENDIAN_INT32(g[i].p);
		*(uint16*)(lt+p*8+4)=B_HOST_TO_BENDIAN_INT16(g[i].c);
	}
	delete	g;
	
printf("write loca-table\n");
	fseek(ofp,hdl,0);
	fwrite(lt,8,ltc,ofp);
	delete	lt;
	
	*(uint32*)wb=B_HOST_TO_BENDIAN_INT32(ofl);
	fseek(ofp,4,0);
	fwrite(wb,4,1,ofp);
	fclose(ofp);

printf("set MIME\n");
	BFile	wf(ofn,B_WRITE_ONLY);
	BAppFileInfo	wfi(&wf);
	wfi.SetType("application/x-vnd.Be-bitmap-font");

	quit("");
}

void mkbmf::xfer(uint16 c,uchar *d)
{
	b->Lock();
	v->FillRect(BRect(0,0,w-1,h-1),B_SOLID_LOW);
	char	s[2],t[8];
	int32	sl,tl,st;
	s[0]=c>>8;	s[1]=c&255;	sl=2;	tl=8;
	convert_to_utf8(B_UNICODE_CONVERSION,s,&sl,t,&tl,&st);
	v->DrawString(t,tl,BPoint(ox,oy));
	v->Sync();
	b->Unlock();
	uint32	*bmp=(uint32*)(b->Bits());
	for(int i=0;i<w*h;i++)d[i]=B_BENDIAN_TO_HOST_INT32(*(bmp+i))>>24;
}
